--- megabyte's RA2 export script
--- kthxbai

utility GMFExport "RA2 GMF Export Tools"
(
	group "Geometry"
	(
		checkbox geo_parents "main_display"
		checkbox geo_normals "flip normal verts" toolTip: "May fix lighting problems with large discular objects"
		button exportGeometryButton "Export" toolTip:"Export Selected Model as a LIGHT"	
	)
	
	group "Light"
	(
		button exportLightButton "Export" toolTip:"Export Selected Model as a LIGHT"
	)

	group "GMID Attachment"
	(
		label lbl1 "Attachment Data:"
		editText att_data ""
		button exportGMIDAButton "Export" toolTip:"Export Selected Model as a GMID_PATTACHMENT"
	)

	group "NodeTM Offset"
	(
		label lbl2 "x:"
		editText offX "0.0"
		label lbl3 "y:"
		editText offY "0.0"
		label lbl4 "z:"
		editText offZ "0.0"
		button grabTMButton "Grab" toolTip:"Grab this objects nodeXYZ"	
	)
	
	on exportGMIDAButton pressed do
	(

	file_out = "c:\\test.txt"
	if file_out == undefined then return false

	fstream = createFile file_out
	if fstream == undefined then
	(
		messagebox "Error opening file\n"
		return false
	)
	
	format "	*GMID_ATTACHMENTPT\n	{\n" to:fstream
	format "		*NODE_NAME	%\n" $.name to:fstream
	format "		*NODE_TM\n		{\n" to:fstream
	format "			*NODE_NAME	%\n" $.name to:fstream
	format "			*TM_ROW0 %	%	%\n" (0 + $.objecttransform.row1.x) (0 + $.objecttransform.row1.y) (0 + $.objecttransform.row1.z) to:fstream
	format "			*TM_ROW1 %	%	%\n" (0 + $.objecttransform.row2.x) (0 + $.objecttransform.row2.y) (0 + $.objecttransform.row2.z) to:fstream
	format "			*TM_ROW2 %	%	%\n" (0 + $.objecttransform.row3.x) (0 + $.objecttransform.row3.y) (0 + $.objecttransform.row3.z) to:fstream
	format "			*TM_ROW3 %	%	%\n" (0 + $.objecttransform.row4.x + (offX.text as float)) (0 + $.objecttransform.row4.z + (offY.text as float)) (0 + $.objecttransform.row4.y + (offZ.text as float)) to:fstream
	format "		}\n" to:fstream
	format "		USER DATA	%\n" att_data.text to:fstream
	format "	}\n" to:fstream
	
	close fstream
	)

	on exportLightButton pressed do
	(

	file_out = "c:\\test.txt"
	if file_out == undefined then return false

	fstream = createFile file_out
	if fstream == undefined then
	(
		messagebox "Error opening file\n"
		return false
	)
	
	format "	*LIGHT\n	{\n" to:fstream
	format "		*NODE_NAME	%\n" $.name to:fstream
	format "		*NODE_TM\n		{\n" to:fstream
	format "			*NODE_NAME	%\n" $.name to:fstream
	format "			*TM_ROW0 %	%	%\n" (0 + $.objecttransform.row1.x) (0 + $.objecttransform.row1.z) (0 + $.objecttransform.row1.y) to:fstream
	format "			*TM_ROW1 %	%	%\n" (0 + $.objecttransform.row2.x) (0 + $.objecttransform.row2.z) (0 + $.objecttransform.row2.y) to:fstream
	format "			*TM_ROW2 %	%	%\n" (0 + $.objecttransform.row3.x) (0 + $.objecttransform.row3.z) (0 + $.objecttransform.row3.y) to:fstream
	format "			*TM_ROW3 %	%	%\n" (0 + $.objecttransform.row4.x + (offX.text as float)) (0 + $.objecttransform.row4.y + (offY.text as float)) (0 + $.objecttransform.row4.z + (offZ.text as float)) to:fstream
	format "		}\n" to:fstream

	format "		*LIGHT_TYPE	Omni\n" to:fstream
	format "		*LIGHT_SHADOWS	Raytraced\n"  to:fstream
	format "		*USE_LIGHT	1\n"  to:fstream
	format "		*LIGHT_SPOTSHAPE	Circle\n"	to:fstream
	format "		*LIGHT_COLOR	x0777777\n" to:fstream
	format "		*LIGHT_INTENS	%\n"  $.multiplier to:fstream
	format "		*LIGHT_ASPECT	-1.000000\n"  to:fstream
	format "		*LIGHT_ATTNSTART	%\n" $.farattenstart to:fstream
	format "		*LIGHT_ATTNEND	%\n" $.farattenend to:fstream
	format "		*LIGHT_TDIST	-0.025400\n" to:fstream
	format "		*USE FAR ATTENUATION =	1\n" to:fstream
	format "	}\n" to:fstream
	
	close fstream
	)

	on exportGeometryButton pressed do
	(

	file_out = "c:\\test.txt"
	if file_out == undefined then return false
	
	fstream = createFile file_out
	
	if fstream == undefined then
	(
		messagebox "Error opening file\n"
		return false
	)
	theObj = $	
	geo = snapshotAsMesh theObj
	
	format "	*GEOMOBJECT\n	{\n" to:fstream
	format "		*NODE_NAME	%\n" $.name to:fstream
	if geo_parents.checked == true then
	(
		format "		*NODE_PARENT	main_display\n" to:fstream
	)
	format "		*NODE_SHADEVERTS	0\n" to:fstream
	format "		*NODE_TM\n		{\n" to:fstream
	format "			*NODE_NAME	%\n" $.name to:fstream
	format "			*TM_ROW0 %	%	%\n" (0 + $.objecttransform.row1.x) (0 + $.objecttransform.row1.y) (0 + $.objecttransform.row1.z) to:fstream
	format "			*TM_ROW1 %	%	%\n" (0 + $.objecttransform.row2.x) (0 + $.objecttransform.row2.y) (0 + $.objecttransform.row2.z) to:fstream
	format "			*TM_ROW2 %	%	%\n" (0 + $.objecttransform.row3.x) (0 + $.objecttransform.row3.y) (0 + $.objecttransform.row3.z) to:fstream
	format "			*TM_ROW3 %	%	%\n" (0 + $.objecttransform.row4.x + (offX.text as float)) (0 - $.objecttransform.row4.z - (offZ.text as float)) (0 + $.objecttransform.row4.y + (offY.text as float)) to:fstream
	format "		}\n" to:fstream
	format "		*MESH\n		{\n" to:fstream
	
	-- Now we export mesh data, starting with header
	-- properties
	
	format "			*TIMEVALUE	%\n" currenttime.ticks to:fstream
	format "			*MESH_NUMVERTEX	%\n" geo.numVerts to:fstream
	format "			*MESH_NUMFACES	%\n" geo.numFaces to:fstream
	
	format "			*MESH_VERTEX_LIST\n			{\n" to:fstream
	for i = 1 to geo.numVerts do
	(
		local vert = getVert geo i
		format "				*MESH_VERTEX	%	%	%	%\n" (I-1) vert.x vert.z vert.y to:fstream
	)
	format "			}\n" to:fstream
	
	format "			*MESH_FACE_LIST\n			{\n" to:fstream
	for i = 1 to geo.numfaces do
	(
		local vert = getFace geo i
		format "				*MESH_FACE	%	A:%	B:%	C:%	*MESH_MTDLID %\n" (I-1) (vert.x as integer -1) (vert.y as integer -1) (vert.z as integer-1) (getfacematid geo i as integer - 1) to:fstream
	)
	format "			}\n" to:fstream
	
	if geo.numtverts != 0 then
	(
	format "			*MESH_NUMTVERTEX	%\n" geo.numtVerts to:fstream
	format "			*MESH_TVERTLIST\n			{\n" to:fstream
	for i = 1 to geo.numtVerts do
	(
		local vert = getTVert geo i
		format "				*MESH_TVERT	%	%	%	%\n" (I-1) vert.x vert.y vert.z to:fstream
	)
	format "			}\n" to:fstream
	format "			*MESH_NUMTVFACES	%\n" geo.numfaces to:fstream
	format "			*MESH_TFACELIST\n			{\n" to:fstream
	for i = 1 to geo.numfaces do
	(
		local vert = getTVface geo i
		format "				*MESH_TFACE	%	%	%	%\n" (I-1) (vert.x as integer - 1) (vert.y as integer - 1) (vert.z as integer - 1) to:fstream
	)
	format "			}\n" to:fstream
	)
	
	format "			*MESH_NORMALS\n			{\n" to:fstream
	for i = 1 to geo.numfaces do
	(
		local vert = getFace geo i
		format "				*MESH_FACENORMAL	%	%	%	%\n" (I-1) (0 + (getfacenormal geo i).x) (0 + (getfacenormal geo i).y) (0 + (getfacenormal geo i).z) to:fstream
		
		if geo_normals.checked == false then
		(
		format "					*MESH_VERTEXNORMAL	%	%	%	%\n" (vert.x as integer -1) (0 - (getnormal geo vert.x).x) (0 - (getnormal geo vert.x).y) (0 - (getnormal geo vert.x).z) to:fstream
		format "					*MESH_VERTEXNORMAL	%	%	%	%\n" (vert.y as integer -1) (0 - (getnormal geo vert.y).x) (0 - (getnormal geo vert.y).y) (0 - (getnormal geo vert.y).z) to:fstream
		format "					*MESH_VERTEXNORMAL	%	%	%	%\n" (vert.z as integer -1) (0 - (getnormal geo vert.z).x) (0 - (getnormal geo vert.z).y) (0 - (getnormal geo vert.z).z) to:fstream
		)
		if geo_normals.checked == true then
		(
		format "					*MESH_VERTEXNORMAL	%	%	%	%\n" (vert.x as integer -1) (0 + (getnormal geo vert.x).x) (0 + (getnormal geo vert.x).z) (0 + (getnormal geo vert.x).y) to:fstream
		format "					*MESH_VERTEXNORMAL	%	%	%	%\n" (vert.y as integer -1) (0 + (getnormal geo vert.y).x) (0 + (getnormal geo vert.y).z) (0 + (getnormal geo vert.y).y) to:fstream
		format "					*MESH_VERTEXNORMAL	%	%	%	%\n" (vert.z as integer -1) (0 + (getnormal geo vert.z).x) (0 + (getnormal geo vert.z).z) (0 + (getnormal geo vert.z).y) to:fstream
		)
	)
	format "			}\n" to:fstream
	
	format "			*BACKFACE_CULL	1\n" to:fstream
	format "			*MATERIAL_REF	0\n" to:fstream
	
	format "		}\n" to:fstream
	format "	}\n" to:fstream
	
	close fstream
	
	messagebox "File saved successfully"	
	)
)